## supertux 0.1.3

=== debian/changelog ===
supertux (0.1.3-3) unstable; urgency=low

  * Add build dependency on zlib1g-dev to fix FTBFS. (Closes: #669496)

 -- Vincent Cheng <Vincentc1208@gmail.com>  Thu, 19 Apr 2012 18:33:42 -0700

supertux (0.1.3-2) unstable; urgency=low

  * Team upload.

  [ Vincent Cheng ]
  * Update list of Maintainers and Uploaders in debian/control to match
    current version in experimental. (Closes: #661458)
    - Add myself to Uploaders.
  * Acknowledge previous NMU, thanks to Peter Eisentraut.
  * Backport various updates from the version of supertux in experimental:
    - Convert package to source format "3.0 (quilt)".
    - Update homepage.
    - Added Vcs-* fields.
    - Update debian/copyright.
    - Remove debian/{,supertux-data).dirs.
    - Added debian/{supertux,supertux-data}.install.
    - Update debian/rules using dh7 style rules.
  * Add b-d on autotools-dev.
  * Update versioned depends on supertux-data in debian/control.
  * Bump standards version from 3.6.2 to 3.9.3.
  * Bump debian compat level from 4 to 9.
  * Added debian/watch.
  * Fix icon path in supertux's menu entry file. (Closes: #407357)

  [ Paul Wise ]
  * Fix Vcs-Browser field

 -- Vincent Cheng <Vincentc1208@gmail.com>  Fri, 02 Mar 2012 15:09:18 -0800

supertux (0.1.3-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fixed bashism in debian/rules (patch by Chris Lamb) (Closes: #484445)
  * Don't ignore error from make distclean, per lintian
  * Added Homepage control field
  * Fixed/updated menu section
  * Use correct configure options according to autotools-dev README.Debian

 -- Peter Eisentraut <petere@debian.org>  Thu, 03 Jul 2008 15:04:28 +0200

supertux (0.1.3-1.1) unstable; urgency=low

  * NMU as part of the GCC 4.1 transition.
  * Remove extra qualification from C++ header file. (closes: #356228)

 -- Martin Michlmayr <tbm@cyrius.com>  Thu, 25 May 2006 18:26:50 +0200

supertux (0.1.3-1) unstable; urgency=low

  * New upstream version.
  * Bump Standards-Version.
  * G++ transition upload. Fixes in Build-Depends line to ensure we'll use
    correct dependencies.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Sun, 10 Jul 2005 19:49:12 +0200

supertux (0.1.2-4) unstable; urgency=high

  * Urgency high cause we really need this fix in sarge.
  * Rebuilding without presence of nvidia-glx. (Closes: #282071, #285946)
  * Added Build-Conflicts: nvidia-glx, to avoid similar situations 
    in the future.
  * Added myself to Uploaders.

 -- Bartosz Fenski <fenio@debian.org>  Wed, 16 Feb 2005 11:55:13 +0100

supertux (0.1.2-3) unstable; urgency=low

  * Added icon to menu. (closes: #275593)
  * Cleaned debian/{rules,copyright}

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Wed, 20 Oct 2004 13:27:22 +0200

supertux (0.1.2-2) unstable; urgency=low

  * Add versioning to leveldata depends.
  * Fix copying missing file in debian/rules. (Closes: 273545).

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Mon, 27 Sep 2004 00:17:26 +0200

supertux (0.1.2-1) unstable; urgency=low

  * New upstream version.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Wed, 25 Aug 2004 23:49:00 +0200

supertux (0.1.1-1) unstable; urgency=low

  * New upstream version.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Thu, 13 May 2004 22:41:39 +0200

supertux (0.1.0-1) unstable; urgency=low

  * Initial Release.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Thu,  6 May 2004 10:36:38 +0200
