=== debian/control ===
Source: supertux
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Bartosz Fenski <fenio@debian.org>,
  Christoph Egger <christoph@debian.org>,
  Alexander Reichle-Schmehl <tolimar@debian.org>,
  Vincent Cheng <Vincentc1208@gmail.com>
Build-Depends: debhelper (>= 9),
  autotools-dev,
  libsdl1.2-dev (>=1.2.7+1.2.8cvs20041007-5.2),
  libsdl-image1.2-dev (>= 1.2.3-5),
  libsdl-mixer1.2-dev,
  zlib1g-dev
Build-Conflicts: nvidia-glx, nvidia-glx-legacy
Standards-Version: 3.9.3
Vcs-Svn: svn://svn.debian.org/svn/pkg-games/packages/trunk/supertux/
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-games/packages/trunk/supertux/
Homepage: http://supertux.lethargik.org/

Package: supertux
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, supertux-data (= ${source:Version})
Description: Classic 2D jump 'n run sidescroller with Tux
 SuperTux is a classic 2D jump 'n run sidescroller game in a similar
 style like the original SuperMario games. You play the role of Tux the
 Penguin, who must rescue Penny from the hands of the evil Nolok.

Package: supertux-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: supertux
Description: Classic 2D jump 'n run sidescroller with Tux (data files)
 SuperTux is a classic 2D jump 'n run sidescroller game in a similar
 style like the original SuperMario games. You play the role of Tux the
 Penguin, who must rescue Penny from the hands of the evil Nolok.
 .
 This package contains the data files required by SuperTux.
