=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autotools-dev

override_dh_auto_configure:
	dh_auto_configure -- --prefix=/usr --bindir=\$${prefix}/games \
	                     --datadir=\$${prefix}/share/games

override_dh_install:
	dh_install --list-missing
