=== debian/watch ===
version=3
opts=downloadurlmangle=s/prdownload/download/ \
http://developer.berlios.de/project/showfiles.php?group_id=3467 http://prdownload.berlios.de/supertux/supertux-(0.1.[\d\.]*[a-z]?).tar.bz2
