=== tools/miniswig/CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,8 @@
 ## add additional compiler switches
 
 ADD_DEFINITIONS(-include ${CMAKE_BINARY_DIR}/config.h)
-REMOVE_DEFINITIONS(-Wall)
+# the autogenerated bison/flex is not warning free usually
+REMOVE_DEFINITIONS(-Wall -W)
 
 ## Include paths to make generated files work
