=== debian/changelog ===
supertux (0.3.3-6) experimental; urgency=low

  * Add debian/patches/fix_joystick_conf_loss.patch: stop overwriting user's
    joystick configuration with default values when joystick is not plugged in.
    (Closes: #706564)
  * Fix vcs-field-not-canonical.
  * Bump standards version from 3.9.3 to 3.9.4.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Thu, 23 May 2013 02:52:12 -0700

supertux (0.3.3-5) experimental; urgency=low

  * Add debian/patches/fix_gcc4.7_ftbfs.patch to fix FTBFS with gcc 4.7.
   (Closes: #671538)

 -- Vincent Cheng <Vincentc1208@gmail.com>  Fri, 04 May 2012 14:23:56 -0700

supertux (0.3.3-4) experimental; urgency=low

  * Add myself to Uploaders.
  * Bump standards version from 3.8.4 to 3.9.3.
  * Bump debian compat level from 7 to 9.
  * Remove explicit b-d on quilt; also remove --with-quilt call in
    debian/rules and unneeded debian/README.source.
  * Add DEP-3 headers to included patches.
  * Add debian/patches/fix-{desktop_file,spelling_errors}.patch to fix
    minor issues found by lintian.
  * Split debian-changes patch into separate patches.
  * Update Vcs-Browser link.
  * Update package descriptions with version in unstable.
  * Tighten dependency on supertux-data. (Closes: #577223)
  * Add "Suggests: supertux" field to supertux-data in debian/control.
  * Remove redundant debian/supertux.6; upstream already includes a manpage.
  * Fix path to xpm icon mentionned in debian/supertux.lintian-overrides.
  * Install WHATSNEW.txt as upstream changelog.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Sun, 01 Apr 2012 00:50:03 -0700

supertux (0.3.3-3) experimental; urgency=low

  * Import patch by Ilya Barygin <barygin@gmail.com> to fix building
    with gcc-4.6 (Closes: #640192)

 -- Christoph Egger <christoph@debian.org>  Tue, 11 Oct 2011 22:33:04 +0200

supertux (0.3.3-2) experimental; urgency=low

  * Build-depend un libcurl-dev to make add-ons work
  * Install the desktop file

 -- Christoph Egger <christoph@debian.org>  Wed, 17 Mar 2010 09:43:49 +0100

supertux (0.3.3-1) experimental; urgency=low

  [ Jon Dowland ]
  * update menu section to "Games/Action" for menu policy transition.
    Thanks Linas Žvirblis.

  [ Cyril Brulebois ]
  * Added Vcs-Svn and Vcs-Browser fields in the control file.
  * Dropped Gürkan Sengün from Uploaders since he doesn't want to package this
    game anymore. Thanks for the initial effort.

  [ Jon Dowland ]
  * add Homepage: control field to source stanza

  [ Ansgar Burchardt ]
  * Remove Homepage semi-field from description

  [ Peter De Wachter ]
  * Added watch file.

  [ Christoph Egger ]
  * Drop Cyril Brulebois from uploaders on his request
  * Clean up build system using dh7 autofoo
  * Bump compat to 7
  * Add quilt patch system
  * Adopt build system to upstream supertux -> supertux2 rename
  * New upstream Release
    * Update yopright
  * Adopting by the Debian Games Team (Closes: #535147)
  * Add myself to Uploaders
  * Bump Standards Version from 3.7.2 to 3.8.4
    * Add README.source
    * Wrap Uploaders
  * Update Homepage field

 -- Christoph Egger <christoph@debian.org>  Thu, 04 Mar 2010 15:46:56 +0100

supertux (0.3.0~dfsg-1) experimental; urgency=low

  * New upstream release (Closes: #404676).
  * Ack previous NMU, thanks to Martin Michlmayr.
  * Licensing:
     - Updated copyright by diffing both 0.1.3 and 0.3.0 upstream tarballs,
       added missing GPL headers, updated author and contributor lists.
     - DFSGified version by removing data/sound and data/music from the
       upstream tarball since the licenses are not clear for those files. The
       upstream authors are clarifying this on a wiki page, so we hope we'll
       be able to release a 0.3.0-1 version with all DFSG-free content (thus
       the choice of the tilde a DFSG separator).
     - Added both --disable-sfx and --disable-music options to the command in
       the desktop and the menu files accordingly.
  * Set Maintainer field to `pkg-games-devel'. Added myself as an Uploader.
  * Added a B-D on libphysfs-dev and libopenal-dev.
  * Added a B-D on jam, and changed $(MAKE) to jam accordingly in
    debian/rules.
  * Added a build conflict against nvidia-glx-legacy.
  * Adapted install rule, using jam's -sprefix option.
  * Added a dh_desktop call.
  * Adapted dh_install* parameters:
     - removed `ChangeLog'
  * Removed from debian/docs:
     - NEWS
     - TODO
     - LEVELDESIGN
     - AUTHORS
  * Removed some manuals `cp', but added one to handle the .desktop file,
    waiting for a better solution.
  * Updated versioned dependency on the data package.
  * Updated debian/menu icon path as well as the .desktop one.
    (Closes: #341432, #394222)
  * Made use of .install files and -i/-a parameters to build the packages
    correctly.
  * Bumped Standards-Version from 3.6.2 to 3.7.2 (no change needed).
  * Bumped debhelper compatibility from 4 to 5 (no change needed).
  * Updated manpage and fixed dieresis troubles. Also added a KNOWN BUGS
    section pointing to a thread of the debian-devel-games list.
  * Updated the long description to reflect that OpenGL is now required.

 -- Cyril Brulebois <cyril.brulebois@enst-bretagne.fr>  Mon,  1 Jan 2007 02:09:53 +0100
