=== debian/control ===
--- 
+++ 
@@ -7,14 +7,19 @@
   Alexander Reichle-Schmehl <tolimar@debian.org>,
   Vincent Cheng <Vincentc1208@gmail.com>
 Build-Depends: debhelper (>= 9),
+  libsdl1.2-dev,
+  libsdl-image1.2-dev,
+  libsdl-mixer1.2-dev,
+  libphysfs-dev,
+  cmake,
+  libopenal-dev,
   autotools-dev,
-  libsdl1.2-dev (>=1.2.7+1.2.8cvs20041007-5.2),
-  libsdl-image1.2-dev (>= 1.2.3-5),
-  libsdl-mixer1.2-dev,
-  zlib1g-dev
+  libboost-dev,
+  libglew-dev,
+  libcurl4-gnutls-dev
 Build-Conflicts: nvidia-glx, nvidia-glx-legacy
-Standards-Version: 3.9.3
-Vcs-Svn: svn://svn.debian.org/svn/pkg-games/packages/trunk/supertux/
+Standards-Version: 3.9.4
+Vcs-Svn: svn://anonscm.debian.org/pkg-games/packages/trunk/supertux/
 Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-games/packages/trunk/supertux/
 Homepage: http://supertux.lethargik.org/
