=== debian/watch ===
version=3

opts=dversionmangle=s/.dfsg.*//,downloadurlmangle=s/prdownload/download/ \
http://developer.berlios.de/project/showfiles.php?group_id=3467 http://prdownload.berlios.de/supertux/supertux-([\d\.]*[a-z]?).(?:tgz|tbz2|tar\.(?:gz|bz2|xz))
